package java.rmi.server;

import java.io.ObjectOutput;
import java.rmi.RemoteException;
import java.lang.reflect.Method;
import java.rmi.Remote;
import java.io.Externalizable;

public interface RemoteRef extends Externalizable
{
    public static final long serialVersionUID = 3632638527362204081L;
    public static final String packagePrefix = "sun.rmi.server";
    
    public abstract Object invoke(Remote p0, Method p1, Object[] p2, long p3) throws Exception;
    
    @Deprecated
    public abstract RemoteCall newCall(RemoteObject p0, Operation[] p1, int p2, long p3) throws RemoteException;
    
    @Deprecated
    public abstract void invoke(RemoteCall p0) throws Exception;
    
    @Deprecated
    public abstract void done(RemoteCall p0) throws RemoteException;
    
    public abstract String getRefClass(ObjectOutput p0);
    
    public abstract int remoteHashCode();
    
    public abstract boolean remoteEquals(RemoteRef p0);
    
    public abstract String remoteToString();
}
